<?php
/*
 * Plugin Name: e-Tweet
 * Author: Arun S. Sekhar [Physioblasts, Arun]
 * Author URI: http://www.e107themes.net
 * Requirement: e107 v0.7.xx
 *
 * Copyright (C) 2010 Arun S. Sekhar (http://www.e107themes.net)
 * Released under the terms and conditions of the
 * GNU General Public License (http://www.gnu.org/licenses/gpl.txt)
 *
 * File: credential_verification.php
 * $Source: 
 * $Revision:  $
 * $Date:  $
 * $Author: arunshekher $
 *
*/
if (!defined('e107_INIT')) { exit; }

/* twitter credentials */
function twitter_verification(){
	global $etweet_prefs;
	require_once('twitteroauth/twitteroauth.php');
	$verify_connection = new TwitterOAuth($etweet_prefs['consumerkey'], $etweet_prefs['consumersecret'], $etweet_prefs['twitter_oauth_token'], $etweet_prefs['twitter_oauth_secret']);
	
 switch ($verify_connection->http_code){
	case 401:
		$twitter_msg = '<span class="etwt-cred-err"><strong>'.ETWT_PLUGIN_ALAN_71.'</strong> '.ETWT_PLUGIN_ALAN_63.'</span>';
		break;
	case 200:
		$twitter_msg = '<span class="etwt-cred-ok"><strong>'.ETWT_PLUGIN_ALAN_71.'</strong> '.ETWT_PLUGIN_ALAN_64.'</span>';
		break;
	default:
		$twitter_msg = '<span class="etwt-cred-msg"><strong>'.ETWT_PLUGIN_ALAN_71.'</strong> '.ETWT_PLUGIN_ALAN_65.'</span>';
		break;		
		}
	return $twitter_msg;				 
}


/* bit.ly credentials */
function get_bitly_short_url($url) {
	global $etweet_prefs;
	$connectURL = 'http://api.bit.ly/v3/shorten?login='.$etweet_prefs['bitly_username'].'&apiKey='.$etweet_prefs['bitly_api_key'].'&uri='.urlencode($url).'&format=json';
	return curl_get_result($connectURL);
}

/* returns a result form url */
function curl_get_result($url) {
	$ch = curl_init();
	$timeout = 5;
	curl_setopt($ch,CURLOPT_URL,$url);
	curl_setopt($ch,CURLOPT_RETURNTRANSFER,1);
	curl_setopt($ch,CURLOPT_CONNECTTIMEOUT,$timeout);
	$data = curl_exec($ch);
	curl_close($ch);
	return $data;
}

function bitly_verification(){
$short_url = get_bitly_short_url('http://e107themes.net');
$msg = json_decode($short_url);

  switch ($msg->{'status_txt'}) {	  
	  case 'MISSING_ARG_LOGIN':
		  $bitly_msg = '<span class="etwt-cred-err"><strong>'.ETWT_PLUGIN_ALAN_72.'</strong> '.ETWT_PLUGIN_ALAN_73.'</span>';
		  break;
	  case 'MISSING_ARG_APIKEY':
		  $bitly_msg = '<span class="etwt-cred-err"><strong>'.ETWT_PLUGIN_ALAN_72.'</strong> '.ETWT_PLUGIN_ALAN_68.'</span>';
		  break;
	  case 'INVALID_LOGIN':
		  $bitly_msg = '<span class="etwt-cred-err"><strong>'.ETWT_PLUGIN_ALAN_72.'</strong> '.ETWT_PLUGIN_ALAN_66.'</span>';		
		  break;
	  case 'INVALID_APIKEY':
		  $bitly_msg = '<span class="etwt-cred-err"><strong>'.ETWT_PLUGIN_ALAN_72.'</strong> '.ETWT_PLUGIN_ALAN_67.'</span>';
		  break;	  
	  case 'OK':
		  $bitly_msg = '<span class="etwt-cred-ok"><strong>'.ETWT_PLUGIN_ALAN_72.'</strong> '.ETWT_PLUGIN_ALAN_69.'</span>';
		  break;
	  default:
		  $bitly_msg = '<span class="etwt-cred-msg"><strong>'.ETWT_PLUGIN_ALAN_72.'</strong> '.ETWT_PLUGIN_ALAN_70.'</span>';
		  break;
  }
return $bitly_msg;
}
?>