<?php
/*
 * Plugin Name: e-Tweet
 * Author: Arun S. Sekhar [Physioblasts, Arun]
 * Author URI: http://www.e107themes.net
 * Requirement: e107 v0.7.xx
 *
 * Copyright (C) 2010 Arun S. Sekhar (http://www.e107themes.net)
 * Released under the terms and conditions of the
 * GNU General Public License (http://www.gnu.org/licenses/gpl.txt)
 *
 * File: etweet.php
 * $Source: 
 * $Revision:  $
 * $Date:  $
 * $Author: arunshekher $
 *
*/
if (!defined('e107_INIT')) { exit; }

/* this goes out when the credential validation check comes in */
if(function_exists('curl_init')){
	require_once('twitteroauth/twitteroauth.php');
}

global $etweet_prefs;
/* print_r($etweet_prefs); */


/* function to shorten url with bit.ly - retuns text format */
function get_bitly_short_url($url, $format='txt') {
	global $etweet_prefs;
	$connectURL = 'http://api.bit.ly/v3/shorten?login='.$etweet_prefs['bitly_username'].'&apiKey='.$etweet_prefs['bitly_api_key'].'&uri='.urlencode($url).'&format='.$format;
	return curl_get_result($connectURL);
}
/* support function for curl call */
function curl_get_result($url) {
	$ch = curl_init();
	$timeout = 5;
	curl_setopt($ch,CURLOPT_URL,$url);
	curl_setopt($ch,CURLOPT_RETURNTRANSFER,1);
	curl_setopt($ch,CURLOPT_CONNECTTIMEOUT,$timeout);
	$data = curl_exec($ch);
	curl_close($ch);
	return $data;
}

/* function to update twitter status. */
function update_twitterStatus($tweet){
	global $etweet_prefs;		
	$twitter_con = new TwitterOAuth($etweet_prefs['consumerkey'], $etweet_prefs['consumersecret'], $etweet_prefs['twitter_oauth_token'], $etweet_prefs['twitter_oauth_secret']);	
	$twitter = $twitter_con->post( 'statuses/update',  array('status' => $tweet));
	return $twitter;	
}
	
/* e-Tweet News Posts. */
function etweet_newspost($data){	
		global $e_event, $etweet_prefs, $tp;
		
		/* process news data. */
		$news_title =  strip_tags($data['news_title']);
		$news_body = strip_tags($tp->toHTML($data['data'], true, 'RAWTEXT'));
		$news_body = $tp->text_truncate($news_body, 15, "...");            
		$news_id =  $data['news_id'];
		$news_url = SITEURL . 'news.php?item.' . $news_id;
		
		 /* get shortened url with bit.ly */
		$short_url = get_bitly_short_url($news_url);	
		
		/* create status. */
		$status = $etweet_prefs['news_prefix'] . ' ' . $news_title . ' - ' . $news_body . ' ' . $short_url . ' ' . $etweet_prefs['news_suffix'];
		
		/* check if status length is longer than 140, and shortens as needed. */
		$status = (strlen($status) <= 140) ? $status : $etweet_prefs['news_prefix'] . ' ' . substr($news_title . ' - ' . $news_body, 0, (-(strlen($status) - 137)))  . '... ' . $short_url . ' ' . $etweet_prefs['news_suffix'];
					
		/* some checks for news class start date etc - a betterway later */	
		$etwt_NCArray = explode(",", $data['news_class']);
		$etwt_newsstart = $data['news_start'];
									  
		if(!(in_array("255", $etwt_NCArray) || in_array("254", $etwt_NCArray) || $etwt_newsstart > time())){				
			/* update status to twitter. */		
			update_twitterStatus($status);								
			}
}
	  
/* e-Tweet Download Posts. */
function etweet_dlpost($data){			
		global $e_event, $etweet_prefs, $tp;			
		
		/* process download data. */
		$download_name = strip_tags($data['download_name']);
		$download_description = strip_tags($tp->toHTML($data['download_description'], true, 'RAWTEXT'));
		$download_description = $tp->text_truncate($download_description, 20, "...");
		$download_author = $data['download_author'];
		$download_id =  $data['download_id'];
		$download_url = SITEURL . 'download.php?view.' . $download_id;
		
		/* get download class from db */
		if(!is_object($sql)){ $sql = new db; }
		$sql->db_select("download", "download_class", "download_id = '".$download_id."'");
		$download_array = $sql->db_Fetch();			
		$download_class = $download_array['download_class'];
			
		 /* get shortened url with bit.ly */
		$short_url = get_bitly_short_url($download_url);			
		
		/* create status. */
		$status = $etweet_prefs['download_prefix'] . ' ' . $download_name . ' - ' . $download_description . ' ' . $short_url . ' ' . $etweet_prefs['download_suffix'];
		
		/* check if status length is longer than 140, and shortens as needed. */
		$status = (strlen($status) <= 140) ? $status : $etweet_prefs['download_prefix'] . ' ' . substr($download_name . ' - ' . $download_description, 0, (-(strlen($status) - 137)))  . '... ' . $short_url . ' ' . $etweet_prefs['download_suffix'];
				
		/* check download is active download class is public - currently checks downlod accessability not visibility	*/		
		if($data['download_active'] && !($download_class == 255 || $download_class == 254)){				
			/* update status to twitter. */	
			update_twitterStatus($status);
			}
}
	
/* e-Tweet Content Posts. */
function etweet_content($data){	
		global $e_event, $etweet_prefs, $tp;
					
		/* process content data */
		$content_heading = strip_tags($data['content_heading']);
		$content_author = strip_tags($data['content_author']);
		
		
		/* fetch content_id for triggered item from db for content url creation as the $data array don't pass it */
		if(!is_object($sql)){ $sql = new db; }
		$sql->db_Select("pcontent", "content_id, content_text, content_datestamp, content_class", "ORDER BY content_datestamp DESC", "nowhere");
		$content_array = $sql->db_Fetch("ALL", 1, 1);
		
		/* content body */
		$content_text = strip_tags($tp->toHTML($content_array['content_text'], true, 'RAWTEXT'));
		$content_text = $tp->text_truncate($content_text, 15, "...");
		
		
		/* create content url. */
		$content_id =  $content_array['content_id'];
		$content_url = SITEURLBASE . e_PLUGIN_ABS . 'content/content.php?content.' . $content_id;
		
		/* content class */
		$content_class = $content_array['content_class'];
		/* content start time */
		$content_starttime = $content_array['content_datestamp'];
		
		 /* get shortened url with bit.ly */
		$short_url = get_bitly_short_url($content_url);	
					
		/* create status. */
		$status = $etweet_prefs['content_prefix'] . ' ' . $content_heading . ' - ' . $content_text . ' ' .  ETWT_PLUGIN_ALAN_48 . ' ' . $content_author . ' ' . $short_url . ' ' . $etweet_prefs['content_suffix'];
		
		/* check if status length is longer than 140, and shortens as needed. */
		$status = (strlen($status) <= 140) ? $status : $etweet_prefs['content_prefix'] . ' ' . substr($content_heading . ' - ' . $content_text . ' ' . ETWT_PLUGIN_ALAN_48 . ' ' . $content_author, 0, (-(strlen($status) - 137)))  . '... ' . $short_url . ' ' . $etweet_prefs['content_suffix'];
		  
		
		/* check content access class content start time etc */
		if(!($content_class == 255 || $content_class == 254 || $content_starttime > time())){					 
			/* update status to twitter. */	
			update_twitterStatus($status);
			}
}

/* e-Tweet Chatbox Posts */
function etweet_chatboxpost($data){	
	  global $e_event, $etweet_prefs, $tp;
		  
	  /* process chatbox message */
	  $chat_msg = strip_tags($tp->toHTML($data['cmessage'], true, 'RAWTEXT'));
	  $chat_msg = $tp->text_truncate($chat_msg, 80, "...");
	  
	  /* chat page url */
	  $chat_url = SITEURLBASE . e_PLUGIN_ABS ."chatbox_menu/chat.php";
	  /* short url */
	  $short_url = get_bitly_short_url($chat_url);
		  
	  /* create status. */
	  $status = $etweet_prefs['chatbox_prefix'] . ' ' . $chat_msg . ' - ' . $short_url . ' ' . $etweet_prefs['chatbox_suffix'];
			  
	  /* check if status length is longer than 140, and shortens as needed. */
	  $status = (strlen($status) <= 140) ? $status : $etweet_prefs['chatbox_prefix'] . ' ' . substr($chat_msg, 0, (-(strlen($status) - 137)))  . '... ' . $short_url . ' ' . $etweet_prefs['chatbox_suffix'];
	  
	  /* update status to twitter. */
	  update_twitterStatus($status);
			
}

/* e-Tweet Chatbox2 Posts */
function etweet_chatbox2post($data){
	  global $e_event, $etweet_prefs, $tp;
	  
	  /* process chatbox2 message */
	  $chat2_msg = strip_tags($tp->toHTML($data['cmessage'], true, 'RAWTEXT'));
	  $chat2_msg = $tp->text_truncate($chat2_msg, 80, "...");
	  
	  /* chat page url */
	  $chat_url = SITEURLBASE . e_PLUGIN_ABS ."chatbox2_menu/chat2.php";
	  /* short url */
	  $short_url = get_bitly_short_url($chat_url);	
	  
	  /* create status. */
	  $status = $etweet_prefs['chatbox_prefix'] . ' ' . $chat2_msg . ' - ' . $short_url . ' ' . $etweet_prefs['chatbox_suffix'];
			  
	  /* check if status length is longer than 140, and shortens as needed. */
	  $status = (strlen($status) <= 140) ? $status : $etweet_prefs['chatbox_prefix'] . ' ' . substr($chat2_msg, 0, (-(strlen($status) - 137)))  . '... ' . $short_url . ' ' . $etweet_prefs['chatbox_suffix'];
	  
	  /* update status to twitter. */
	  update_twitterStatus($status);
	
}



?>
